import { test, expect, Page } from '@playwright/test';
import path from 'path';
import { off } from 'process';

let page: Page;

test.beforeAll(async ({ browser }) => {
  page = await browser.newPage();
});

test.afterAll(async () => {
  if (page !== undefined) {
    await page.close();
  }
});

test('Login', async () => {
  // Login
  await page.goto('http://192.168.1.90:20001/');
  await expect(page).toHaveTitle(/^Sign in to /);
  await page.fill("input[name='username']", 'admin');
  await page.fill("input[name='password']", '1234');
  await page.click('id=kc-login');
  await page.waitForTimeout(2000);
  //   await page.click('id=acceptBtn');
});

test('Create Branch Managenment', async () => {
  try {
    await page.click('id=menu-icon-branch-management');
    await page.click('id=hq-add-btn');
    // await page.click('id=btn-Add');
    // await page.click("(//div[@class='q-avatar relative-position'])[2]");

    // const fileInput = page.locator(
    //   "//div[@class='image-dialog-body']//button[1]",
    // );
    // await fileInput.waitFor({ state: 'visible' });

    // // อัปโหลดไฟล์
    // await fileInput.setInputFiles(
    //   '/Users/linping/Desktop/Chamomind&FrappeT/JWS_TestScript/tests/Datafile/Pic1.jpg',
    // ); // เปลี่ยน path ให้ตรง

    // await page.setInputFiles(
    //   "//div[@class='image-dialog-body']//button[1]",
    //   '/Users/linping/Desktop/Chamomind&FrappeT/JWS_TestScript/tests/Datafile/Pic1.jpg',
    // );
    // // UploadFile

    // ส่วนข้อมูลพื้นฐาน
    await page.fill("(//input[@id='input-abbreviation'])[2]", 'CMM');
    await page.fill("(//input[@id='input-tax-no'])[2]", '1260846220284');
    await page.fill("(//input[@id='input-name'])[3]", 'บริษัท คาโมมายด์ จำกัด');
    await page.fill("(//input[@id='input-name-en'])[2]", 'CHAMOMIND');
    await page.fill(
      "(//input[@aria-label='เลขที่ใบอนุญาต'])[2]",
      '1228222822822',
    );

    // ส่วนติดต่อ
    await page.fill("(//input[@id='input-email'])[2]", 'cmm@support.com');
    await page.fill("(//input[@id='input-telephone-no'])[2]", '022222262');
    await page.fill("(//input[@id='input-contact-name'])[2]", 'คุณต่อ');
    await page.fill("(//input[@id='input-contact'])[2]", '0866224228');
    await page.fill("(//input[@id='input-line-id'])[2]", 'local2024');

    // ส่วนที่อยู่
    await page.fill("(//input[@id='default-input-address-no'])[2]", '20/02');
    await page.fill("(//input[@id='default-input-moo'])[3]", '1');
    await page.click("(//input[@id='default-select-province'])[2]");
    await page.click("//div[@role='option']");
    await page.click("(//input[@id='default-select-district'])[2]");
    await page.waitForTimeout(1000);
    await page.click("//div[@role='option']");
    await page.click("(//input[@id='default-select-sub-district'])[2]");
    await page.waitForTimeout(1000);
    await page.click("//div[@role='option']");
    await page.fill("(//input[@id='default-input-address-en'])[2]", '20/02');
    await page.fill("(//input[@aria-label='Moo'])[2]", '1');

    //ส ส่วนบัญชีธนาคาร
    await page.click("(//input[@id='select-bankbook'])[3]");
    await page.click('id=select-bankbook_1');
    await page.fill("(//input[@aria-label='เลขบัญชี'])[2]", '1202282262226');
    await page.fill("(//input[@aria-label='สาขาธนาคาร'])[2]", 'เชียงใหม่');
    await page.fill("(//input[@aria-label='ชื่อบัญชี'])[2]", 'Pongpon Kuntana');
    await page.click("(//input[@aria-label='ประเภทบัญชี'])[2]");
    await page.waitForTimeout(2000);
    await page.click('id=select-bankbook_0');
    await page.click('id=btn-form-submit');

    await page.waitForSelector('id=btn-ok-dialog');
    await page.click('id=btn-ok-dialog');

    // ตรวจสอบความถูกต้องหลังจากทำการบันทึกสร้างสำนักงานใหญ่
    const newOfficeLocator = page.locator(
      "//td[contains(.,'บริษัท คาโมมายด์ จำกัดCMM00000')]",
    );
    await newOfficeLocator.waitFor({ state: 'visible' });

    // ดึงข้อความจาก <td> ที่ตรงกับ XPath
    const newOfficeName = await newOfficeLocator.textContent();

    // ตรวจสอบว่าเนื้อหาที่บันทึกถูกต้อง
    if (newOfficeName !== null) {
      const trimmedName = newOfficeName.trim();
      expect(trimmedName).toBe('บริษัท คาโมมายด์ จำกัดCMM00000');
      console.log('การตรวจสอบสำเร็จ: ข้อมูลถูกต้อง');
    } else {
      throw new Error('ไม่พบข้อมูลที่บันทึกใน <td>');
    }
  } catch (error) {
    console.error('เกิดข้อผิดพลาดในการทดสอบ:', error);
    throw error;
  }

  await page.waitForTimeout(2000);
});

test('Create Branch Managenment Second', async () => {
  try {
    // ส่วนข้อมูลพื้นฐาน
    await page.click('id=hq-add-btn');
    await page.fill("(//input[@id='input-abbreviation'])[2]", 'CMO');
    await page.fill("(//input[@id='input-tax-no'])[2]", '1260846220284');
    await page.fill("(//input[@id='input-name'])[3]", 'บริษัท โคโม่ จำกัด');
    await page.fill("(//input[@id='input-name-en'])[2]", 'COMO');
    await page.fill(
      "(//input[@aria-label='เลขที่ใบอนุญาต'])[2]",
      '1228222822822',
    );

    // ส่วนติดต่อ
    await page.fill("(//input[@id='input-email'])[2]", 'como@support.com');
    await page.fill("(//input[@id='input-telephone-no'])[2]", '022010100');
    await page.fill("(//input[@id='input-contact-name'])[2]", 'คุณอาท');
    await page.fill("(//input[@id='input-contact'])[2]", '0866224228');
    await page.fill("(//input[@id='input-line-id'])[2]", 'como20');

    // ส่วนที่อยู่
    await page.fill("(//input[@id='default-input-address-no'])[2]", '40/04');
    await page.fill("(//input[@id='default-input-moo'])[3]", '2');
    await page.click("(//input[@id='default-select-province'])[2]");
    await page.click("//div[@role='option']");
    await page.click("(//input[@id='default-select-district'])[2]");
    await page.waitForTimeout(1000);
    await page.click("//div[@role='option']");
    await page.click("(//input[@id='default-select-sub-district'])[2]");
    await page.waitForTimeout(1000);
    await page.click("//div[@role='option']");
    await page.fill("(//input[@id='default-input-address-en'])[2]", '40/04');
    await page.fill("(//input[@aria-label='Moo'])[2]", '1');

    // ส่วนธนาคาร
    await page.click("(//input[@id='select-bankbook'])[3]");
    await page.click('id=select-bankbook_4');
    await page.fill("(//input[@aria-label='เลขบัญชี'])[2]", '2022822624262');
    await page.fill("(//input[@aria-label='สาขาธนาคาร'])[2]", 'ลำพูน');
    await page.fill("(//input[@aria-label='ชื่อบัญชี'])[2]", 'Pongpon Kuntana');
    await page.click("(//input[@aria-label='ประเภทบัญชี'])[2]");
    await page.waitForTimeout(2000);
    await page.click('id=select-bankbook_0');
    await page.click('id=btn-form-submit');

    await page.waitForSelector('id=btn-ok-dialog');
    await page.click('id=btn-ok-dialog');

    // ตรวจสอบความถูกต้องหลังจากทำการบันทึกสร้างสำนักงานใหญ่
    const newOfficeLocator = page.locator(
      "//td[contains(.,'บริษัท โคโม่ จำกัดCMO00000')]",
    );
    await newOfficeLocator.waitFor({ state: 'visible' });

    // ดึงข้อความจาก <td> ที่ตรงกับ XPath
    const newOfficeName = await newOfficeLocator.textContent();

    // ตรวจสอบว่าเนื้อหาที่บันทึกถูกต้อง
    if (newOfficeName !== null) {
      const trimmedName = newOfficeName.trim();
      expect(trimmedName).toBe('บริษัท โคโม่ จำกัดCMO00000');
      console.log('การตรวจสอบสำเร็จ: ข้อมูลถูกต้อง');
    } else {
      throw new Error('ไม่พบข้อมูลที่บันทึกใน <td>');
    }
  } catch (error) {
    console.error('เกิดข้อผิดพลาดในการทดสอบ:', error);
    throw error;
  }

  await page.waitForTimeout(2000);
});
